
#include "base.as"

#library    lRings          "Rings.ao"
#library    lModules        "Modules.ao"

import from lRings,lModules

+++
+++  An associative R-algebra is an R-module with a bilinear 
+++  product "*".
+++
define AssociativeAlgebra(R:Rings):Category == Module R with 
    *: (%,%) -> %
 
+++
+++  The category of associative algebras
+++
AssociativeAlgebraCategory(R:Rings):MathCategory AssociativeAlgebra R == add
