

#include "base.as"
#library  lLattices  "Lattices.ao"

import from SingleInteger,lLattices

define TwoLattice(L:Lattice):Category == with
    <=: (%,%) -> L
    /\: (%,%) -> %
    \/: (%,%) -> %
    
define ThreeLattice(L:Lattice,L2:TwoLattice L):Category == with
    <=: (%,%) -> L2
    /\: (%,%) -> %
    \/: (%,%) -> %    

define Goon:Category == with
define Done:Category == with
   
define nLattice:Category == Domain with
    if % has Goon then 
        L:nLattice
	<=:(%,%) -> L
	/\:(%,%) -> %
	\/:(%,%) -> %
    if % has Done then Lattice

Bool1:nLattice with Done == SingleInteger add
    
Integer1Lattice:nLattice with Goon == add
    Rep == SingleInteger; import from Rep
    
    L:nLattice == Bool1 
    (x:%)<=(y:%):L == 
        if (rep x)<=(rep y) then (1$SingleInteger) pretend L
	else                     (0$SingleInteger) pretend L
    (x:%)/\(y:%):% == per ( (rep x) /\ (rep y) )
    (x:%)\/(y:%):% == per ( (rep x) \/ (rep y) )
    
    (t:TextWriter)<<(x:%):TextWriter == t << (rep x) << "'"

import from SingleInteger

five:Integer1Lattice == 5 pretend Integer1Lattice
two: Integer1Lattice == 2 pretend Integer1Lattice 
import from Integer1Lattice,L

print << two << newline
print << five << newline
print << (two <= five) << newline
print << (five <= two) << newline

#if joke

define Lattice:Category == Domain with
    L:Lattice
    <=: (%,%) -> L
    /\: (%,%) -> %
    \/: (%,%) -> %
    
Lat:Lattice == Boolean add
    L:Lattice == error " "
    (x:%)<=(y:%):L == error " "
    
Lat2:Lattice == SingleInteger add
    Rep == SingleInteger; import from Rep
    (t:TextWriter)<<(x:%):TextWriter == t << "[" << (rep x) << ":2" << "]"
    L:Lattice == Lat
    (x:%)<=(y:%):L == 
        b:Boolean == rep x <= rep y
        b pretend L
        
Lat3:Lattice == SingleInteger add
    Rep == SingleInteger; import from Rep
    L:Lattice == Lat
    (t:TextWriter)<<(x:%):TextWriter == t << "[" << (rep x) << ":3" << "]"
    (x:%)<=(y:%):L == 
        b:Boolean == rep x <= rep y
        b pretend L
        
import from SingleInteger 

one:Lat3 == 1 pretend Lat3
three:Lat3 == 3 pretend Lat3 

import from L
print << (one <= three) << newline

print << one << newline
print << three << newline

    
#endif
