
#include "base.as"

define (ObjB:Category)^(ObjA:Category):Category == with
    functor: ObjA -> ObjB
    functor: (X:ObjA,Y:ObjA) -> (X->Y) -> (functor X -> functor Y)

Natural(ObjA:Category,ObjB:Category)(F:(ObjB^ObjA),G:(ObjB^ObjA)):Domain with
    natural:      ( (X:ObjA) -> (functor$F)(X) -> (functor$G)(X) ) -> %
    natural: % -> ( (X:ObjA) -> (functor$F)(X) -> (functor$G)(X) )
    apply:   (%,X:ObjA) -> ( (functor$F)(X) -> (functor$G)(X) )
== add 
    Rep ==>      (X:ObjA)->(functor$F)(X)->(functor$G)(X)
    natural(n:   (X:ObjA)->(functor$F)(X)->(functor$G)(X)):% == per n
    natural(n:%):(X:ObjA)->(functor$F)(X)->(functor$G)(X)    == rep n
    apply(n:%,X:ObjA):(functor$F)(X)->(functor$G)(X) == (rep n)(X)

FunctorCategory(ObjA:Category,ObjB:Category):MathCategory(ObjB^ObjA,Natural(ObjA,ObjB)) == add 
    Obj ==> (ObjB^ObjA)
    Hom(X,Y) ==> Natural(ObjA,ObjB)(X,Y)
    id(A:Obj):Hom(A,A) == natural ( (X:ObjA)(x:(functor$A)(X)):(functor$A)(X) +-> x )
    compose(A:Obj,B:Obj,C:Obj)(n:Hom(A,B),m:Hom(B,C)):Hom(A,C) == 
        FF(X:ObjA):(functor$A)(X)->(functor$C)(X) == 
            FFF (Y:(functor$A)(X)):(functor$C)(X) == 
               M:(functor$B)(X) == n(X)(Y)
               m(X)(M)
            FFF
        natural FF

