
#include "base.as"

#library   lDomains  "Domains.ao"

import from lDomains
+++
+++  Hom functors are from the category in question to Domain rather than set
+++ 
define Hom(Obj:Category,A:Obj,B:Obj):Category == Domain with 
    hom: % -> (A->B)
    hom:      (A->B) -> %

+++
+++  Hom functors and cofunctors
+++
HomFunctors(Obj:Category,Cat:MathCategory Obj):with
    Hom: (X:Obj) -> (A:Obj) -> Hom(Obj,X,A)   
    Hom: (X:Obj) -> (A:Obj,B:Obj,A->B) -> ( Hom(X)(A) -> Hom(X)(B) )
    
    coHom: (X:Obj) -> (A:Obj) -> Hom(Obj,A,X)
    coHom: (X:Obj) -> (A:Obj,B:Obj,A->B) -> ( coHom(X)(B) -> coHom(X)(A) )
== add
    Hom(X:Obj)(A:Obj):Hom(Obj,X,A) == 
        H0:Hom(Obj,X,A) == add
            Rep ==> (X->A)
            hom(f:%):(X->A) == rep f
            hom(f:X->A):%   == per f
            (t:TextWriter)<<(f:%):TextWriter == t << "[Morphism]"
        H0 add        
    Hom(X:Obj)(A:Obj,B:Obj,f:A->B)(a:Hom(X)(A)):Hom(X)(B) == hom ( (compose$Cat)(X,A,B)(hom a,f) )
    
    coHom(X:Obj)(A:Obj):Hom(Obj,A,X) ==
        H1:Hom(Obj,A,X) == add
            Rep ==> (A->X)
            hom(f:%):(A->X) == rep f
            hom(f:A->X):%   == per f
            (t:TextWriter)<<(f:%):TextWriter == t << "[Morphism]"
        H1 add
    coHom(X:Obj)(A:Obj,B:Obj,f:A->B)(a:coHom(X)(B)):coHom(X)(A) == hom ( (compose$Cat)(A,B,X)(f,hom a) )
    
