
#include "base.as"

+++
+++  Forgetful functor from Monoids to Set
+++
Monoid2Set(M:Monoids):Set == M add

+++
+++  Free construction of a Monoid from a Set
+++
Set2Monoid(A:Set):Monoids == add
    Rep == List A; import from Rep
    (t:TextWriter)<<(x:%):TextWriter == (<<$A)(t,rep x)
    1:% == per []
    (x:%)*(y:%):% == per concat ( rep x, rep y)
    (x:%)=(y:%):Boolean == 
        import from SingleInteger
        #(rep x)=#(rep y) => forall? ((rep x).i = (rep y).i for i:SingleInteger in 1..#(rep x))
        false 
+++
+++  Free Construction Adjoint
+++
FreeMonoid:Adjoint(Set,Monoids,Set2Monoid,Monoid2Set) == add 
    <<(A:Set,B:Monoids,f:A->Monoid2Set B):(Set2Monoid A -> B) == 
        F(a:Set2Monoid A):B == 
            import from List A,List B
            al:List A == a pretend List A
            bl:List B == [ (f x) pretend B for x in al ]
            monoidProduct bl
        F
    >>(A:Set,B:Monoids,f:Set2Monoid A -> B):(A -> Monoid2Set B) == 
        F(a:A):Monoid2Set B == 
            import from List A
            aa:Set2Monoid A == [a] pretend Set2Monoid A
            (f aa) pretend Monoid2Set B
        F
              
+++
+++  The Category of Monoids
+++
MonoidCategory: MathCategory Monoids _
     with            Initial Monoids _
     with              Final Monoids _
     with            Product Monoids _ 
== add
---
---   In monoids, the initial and final objects are the trivial monoid containing only the identity.
---
    Zero():Monoids == 
        M2:Monoids == add
	    Rep == SingleInteger; import from Rep
	    (x:%)*(y:%):% == per (1$SingleInteger)
	    1:% == per (1$SingleInteger)
            (t:TextWriter)<<(x:%):TextWriter == t << "*"
            (x:%)=(y:%):Boolean == true
	M2 add
    zero(A:Monoids):(Zero()->A) == (z:Zero()):A +-> 1
    
    One():Monoids == 
        M3:Monoids == Zero() add
            (t:TextWriter)<<(x:%):TextWriter == never
	M3 add
    one(A:Monoids):(A->One()) == (a:A):One() +-> (1$One())

    Product(A:Monoids,B:Monoids):(AB:Monoids,AB->A,AB->B,(X:Monoids)->(X->A,X->B)->(X->AB)) ==     
        RepP == Record(a:A,b:B); import from RepP
	P:Monoids == add
	    Rep == Record(a:A,b:B); import from Rep
	    (x:%)*(y:%):% == per [ (rep x).a * (rep y).a , (rep x).b * (rep y).b ]
            (t:TextWriter)<<(x:%):TextWriter == t << "( " << (rep x).a << ", " << (rep x).a << " )"
	    1:% == per [ 1, 1 ]
            (x:%)=(y:%):Boolean == (rep x).a = (rep y).a and (rep x).b = (rep y).b
        pa:P->A == (p:P):A +-> (p pretend RepP).a
	pb:P->B == (p:P):B +-> (p pretend RepP).b
	product(X:Monoids)(f:X->A,g:X->B):(X->P) == (x:X):P +-> [f x,g x] pretend P 
	(P,pa,pb,product)

